<?php 

function multi_thread_exec_headers($nodes,$host,$RESP_TIMEOUT=30,$GETPARTYROLEID=true,$CUSTOM_REQUEST="")
{
    $CURLOPT_HTTPHEADERS=array();
    $CURLOPT_HTTPHEADERS[0] ='key:'.KEY;
    $CURLOPT_HTTPHEADERS[1]='user:'.$host;
    return multi_thread_exec($nodes,$CURLOPT_HTTPHEADERS,$RESP_TIMEOUT,$GETPARTYROLEID,$CUSTOM_REQUEST);
}

function multi_thread_exec($nodes,$CURLOPT_HTTPHEADERS="",$RESP_TIMEOUT=30,$GETPARTYROLEID=true,$CUSTOM_REQUEST="",$auth="")
{
//print_r($CURLOPT_HTTPHEADERS);exit;
    global $CODEPATH,$ORG_DOMAIN, $ANALYTICSLOGPATH, $info,$debug_info,$response_code,$external_urls;
    $node_count = count($nodes);
    //$RESP_TIMEOUT = $RESP_TIMEOUT*10; // default 5 secs timeout

    $curl_arr = array();
    $master = curl_multi_init();
    $tmp_str_cookies    = "";

    $tmp_arr_httpheader = array("Connection: Close");
    if (!empty($CURLOPT_HTTPHEADERS))
    {
        $tmp_arr_httpheader = array_merge($CURLOPT_HTTPHEADERS,$tmp_arr_httpheader);
    }

    $options = array(
        CURLOPT_RETURNTRANSFER => true,         // return web page
        CURLOPT_HEADER         => false,        // don't return headers
        CURLOPT_FOLLOWLOCATION => true,         // follow redirects
        CURLOPT_ENCODING       => "",           // handle all encodings
        CURLOPT_AUTOREFERER    => true,         // set referer on redirect
        CURLOPT_CONNECTTIMEOUT_MS => 200,          // timeout on connect
//       CURLOPT_TIMEOUT_MS        => $RESP_TIMEOUT,          // timeout on response
        CURLOPT_USERPWD        => trim($auth),
        CURLOPT_MAXREDIRS      => 10,           // stop after 10 redirects
        CURLOPT_SSL_VERIFYHOST => 0,            // don't verify ssl
        CURLOPT_SSL_VERIFYPEER => false,        //
        CURL_HTTP_VERSION_1_1  => 1,
        CURLOPT_NOSIGNAL        => true,
        CURLOPT_ENCODING        => 'gzip,deflate',
        CURLOPT_HTTPHEADER      =>$tmp_arr_httpheader,
        CURLOPT_REFERER         => "http://shipdelight.rediff.com"
    );

    if($tmp_str_cookies !="")
        $options[CURLOPT_COOKIE] = $tmp_str_cookies;


    if($CUSTOM_REQUEST !="")
        $options[CURLOPT_CUSTOMREQUEST] = $CUSTOM_REQUEST;

    for($i = 0; $i < $node_count; $i++)
    {
        $url                = (is_array($nodes[$i]) && !empty($nodes[$i]['url'])) ? $nodes[$i]['url'] : $nodes[$i];
        $resp_timeout =  (is_array($nodes) && !empty($nodes[$i]['resp_timeout'])) ? $nodes[$i]['resp_timeout'] : $RESP_TIMEOUT; // default 5 secs timeout
        $curl_arr[$i]       = curl_init();

        curl_setopt($curl_arr[$i], CURLOPT_URL, $url);
        //      curl_setopt($curl_arr[$i], CURLOPT_TIMEOUT, $resp_timeout);

        if (is_array($nodes[$i]))
        {
            if (!empty($nodes[$i]['post'])) {
                if (is_array($nodes[$i]['post']))
                {
                    $o="";
                    foreach ($nodes[$i]['post'] as $k=>$v)
                    {
                        $o.= "$k=".$v."&";
                    }
                    $post_data=substr($o,0,-1);
                }
                else
                {
                    $post_data = $nodes[$i]['post'];

                }
                curl_setopt($curl_arr[$i], CURLOPT_POST,1);
                curl_setopt($curl_arr[$i], CURLOPT_POSTFIELDS,$post_data);
            }
            elseif (!empty($nodes[$i]['put']))
            {
                if (is_array($nodes[$i]['put']))
                {
                        $o="";
                        foreach ($nodes[$i]['put'] as $k=>$v)
                        {
                                $o.= "$k=".$v."&";
                        }
                        $post_data=substr($o,0,-1);
                }
                else
                {
                        $post_data = $nodes[$i]['put'];

                }
                curl_setopt($curl_arr[$i], CURLOPT_CUSTOMREQUEST,'PUT');
                curl_setopt($curl_arr[$i], CURLOPT_POSTFIELDS,$post_data);
              }
        }
        curl_setopt($curl_arr[$i], CURLOPT_TIMEOUT, $resp_timeout);
        curl_setopt_array($curl_arr[$i],$options);
        //      curl_setopt($curl_arr[$i],"CURLOPT_HTTPHEADER",array("Connection: Close\r\n"));
        curl_multi_add_handle($master, $curl_arr[$i]);

    } // EO for loop

#   $time_start = microtime(true);
    do {
        curl_multi_exec($master,$running);
        //error_log($running." time check".time());
        usleep(5000);
    } while($running > 0);

    //$info = "\n\n";
    //$time_start = microtime(true);
    for($i = 0; $i < $node_count; $i++)
    {
        $results[$i] = curl_multi_getcontent  ( $curl_arr[$i]  );

        $tmp_arr = (curl_getinfo($curl_arr[$i]));
        $gzbytes   = strlen(gzcompress($results[$i], 9));//compress level : 9 for max compress
        $strbytes   = strlen($results[$i]);

        if ($tmp_arr['http_code'] == 404 || $tmp_arr['http_code'] == 500 || $tmp_arr['http_code'] == 503)
        {
            $results[$i] = "";
        }

        curl_multi_remove_handle($master, $curl_arr[$i]);
        curl_close($curl_arr[$i]);
        
        $info .= "\t".$tmp_arr['total_time']; // seconds
        
        //$debug_info1 = $nodes[$i]['url']."\t".$tmp_arr['total_time']."\t".byte_convert($strbytes)."\t".$tmp_arr['http_code']."\t 0 \n";
                $response_code=$tmp_arr['http_code'];
    }
    curl_multi_close($master);

    $info .= "\n";
    return $results;
}

/*
function byte_convert($bytes)
  {
    $symbol = array('B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');

    $exp = 0;
    $converted_value = 0;
    if( $bytes > 0 )
    {
      $exp = floor( log($bytes)/log(1024) );
      $converted_value = ( $bytes/pow(1024,floor($exp)) );
    }

    return sprintf( '%.2f '.$symbol[$exp], $converted_value );
  }
*/

?>
